
//
//
// Copyright(C) 2017,2018,2019 John S Dyson
// All rights reserved.
//
// Refer to audioproc.cpp for license.
// 

#include <sys/types.h>

#include "itqA.h"
#include "itq-typedefs.h"
#include "itq-qdefs.h"
#include "vecmath.h"


#if defined(__clang__)

namespace std
{
enum class align_val_t : size_t {};
};

void* __attribute__((weak))
operator new(size_t memamt, std::align_val_t alignv) 
{
	void *addr = nullptr;

	size_t atmp = int(alignv);
	if (atmp < 64)
		atmp = 64;
	posix_memalign(&addr, atmp, memamt);

	return addr;
}

void* __attribute__((weak))
operator new[](size_t memamt, std::align_val_t alignv) 
{
	void *addr = nullptr;
	size_t atmp = int(alignv);
	if (atmp < 64)
		atmp = 64;
	posix_memalign(&addr, atmp, memamt);


	return addr;
}

void __attribute__((weak))
operator delete( void * addr, std::align_val_t alignv)
{
	if (addr != nullptr) free(addr);
}

void __attribute__((weak))
operator delete[]( void * addr, std::align_val_t alignv)
{
	if (addr != nullptr) free(addr);
}
#endif

	

//
// vim: set ts=4:
//

