#if !defined(__myalloc_h__)
#define __myalloc_h__ 1

#include <malloc.h>
#include <stdio.h>
#include <memory.h>
#include <stdlib.h>

//#if !defined(ONWINDOWS)
#define USEPOSIXMEM
//#endif


//#if !defined(ONWINDOWS)
static __attribute__((noinline, assume_aligned(256), alloc_size(1), malloc, returns_nonnull)) void *
//#else
//static __attribute__((noinline, assume_aligned(32), alloc_size(1), malloc, returns_nonnull)) void *
//#endif
__myalloc(int size)
{
	void *mptr;

#if defined(USEPOSIXMEM)
	if (::posix_memalign(&mptr, 256, size))
	{
		::perror("posix_memalign");
		::exit(1);
	}
#else

/*
	mptr = pvalloc(size);
*/
/*
	mptr = malloc(size + 255);
	if (mptr == NULL)
	{
		::fprintf(stderr,"myalloc: failure allocating memory object of size %d\n", size);
		::exit(1);
	}

	unsigned long long mpint = (unsigned long long)mptr;
	unsigned long long mask = (unsigned long long) 0xff;
	mpint &= ~mask;

	mptr = (void *) mpint;
*/
	mptr = _aligned_malloc(size, 64);

	::memset(mptr, 0, size);
	
#endif

	return mptr;
}


#define myalloc(size) __myalloc(size)

#endif
//
// vim: set ts=4:
//

